	PROGRAM RDFRME
C-----------------------------------------------------------------
C This program reads and types a frame of data from a .C3D file
C-----------------------------------------------------------------
	INTEGER*2 DTYP,NPTS,AVRAT,FRN,CBIT(7)
	REAL*4 FROUT(2000)
	CHARACTER*40 FNAM
C-----------------------------------------------------------------
	INTYP=1 					! assume PC data

    5	WRITE(*,104)
  104	FORMAT(' Enter .C3D file name : ',$)
	READ(*,'(A)') FNAM

	IVLA=0
	LU=2
	OPEN(UNIT=LU,FILE=FNAM,STATUS='OLD',ACCESS='DIRECT',
     *	RECL=512,ERR=5)


   20	READ(2,REC=1) I,NPTS,NANLG,IF1,IF2,I,SCALE,IH,AVRAT

	IF(NANLG.EQ.0) GOTO 42
	IF(AVRAT.GT.0) GOTO 45
	WRITE(*,*) 'Enter analog/video frame rate ratio :'
	READ(*,*) AVRAT

   45	NANLG=NANLG/AVRAT
   42	WRITE(*,*)
	WRITE(*,*) 'Number of points        =',NPTS
	WRITE(*,*) 'Number of video frames  =',IF2-IF1+1
	WRITE(*,*) 'Number of analog chans. =',NANLG
	IF(NANLG.GT.0) WRITE(*,*) 'Analog/video frame rate =',AVRAT
	WRITE(*,*) ' '

   15	WRITE(*,200)
  200	FORMAT(' Output video frames with analogs (1), or analog',
     *	    ' frames only (2) (1/2) ? :',$)
	READ(*,*) DTYP
	IF(DTYP.LT.1.OR.DTYP.GT.2) GOTO 15
	IF(DTYP.EQ.1) GOTO 10
	IF(NANLG.GT.0) GOTO 10
	WRITE(*,*) 'No analog data in this file'
	GOTO 15

   10	WRITE(*,*)
   18	WRITE(*,210)
  210	FORMAT(' Enter frame # : ',$)
	READ(*,*,ERR=18) FRN

	IF(FRN.EQ.0) GOTO 20

	WRITE(*,*)

	CALL GETF(LU,DTYP,FRN,NPTS,NANLG,AVRAT,FROUT,IH,IVLA,
     *	  SCALE,INTYP)

	IF(IVLA.GT.0) GOTO 87
	WRITE(*,*) 'ERROR IN READING FRAME',FRN
	GOTO 10
   87	IF(DTYP.EQ.2) GOTO 25
	K=-3
	IF(NPTS.EQ.0) GOTO 28			! if no points
	DO 22 I=1,NPTS
	K=(I-1)*4+1
	RES=-1.0
	IF(FROUT(K+3).LT.0.0) GOTO 29
	RES=(IFIX(FROUT(K+3)).AND.255)*SCALE

   29	JJ=IFIX(FROUT(K+3))/256			! camera bits
	DO 60 J=1,7				! decode camera bits
	CBIT(8-J)=0
	IF((JJ.AND.1).NE.0) CBIT(8-J)=1
   60	JJ=JJ/2

   22	WRITE(*,100) I,(FROUT(J)*SCALE,J=K,K+2),
     *	RES,(CBIT(J),J=1,7)
  100	FORMAT(I5,8X,3F12.3,F10.3,5X,7I1)
   28	WRITE(*,*)
	WRITE(5,110) (FROUT(I),I=K+4,K+3+NANLG)
	GOTO 10
   25	WRITE(*,110) (FROUT(I),I=1,NANLG)
  110	FORMAT(1X,8F8.0)

	GOTO 10

	END
